/******************************************************************************
   SCI1.h
 *****************************************************************************/

#ifndef SCI1_H
#define SCI1_H

// Defines
#define ECLK 24000000	// Bus clock
//#define SCI1_BAUD_RATE  115200	// Desired baud rate
#define SCI1_BAUD_RATE  9600		// Desired baud rate
#define SCI1_BAUD_DIV (ECLK/16)/SCI1_BAUD_RATE  // Value for baud register
#define rxqsize1  64	// Number of bytes in receive buffer
#define txqsize1  64	// Number of pointers in transmit queue
#define RcvBufSize1 32	// Number of bytes in Receive Buffer
#define DC3 0x13		// XOFF control character
#define DC1 0x11		// XON control character
#define NUL 0x00		// NUL control character
#define STX 0X02		// STX control character
#define ETX 0X03		// ETX control character

typedef char *pnt;

/*
// Rx buffer and the input and output pointers
typedef struct rx_q_struct
{
  word in;        // Input pointer
  word out;       // Output pointer
  char q[rxqsize1];  // Queue array of characters
}rx_q_struct;

// Tx buffer and its input and output pointers
typedef struct tx_q_struct
{
  word in;         // Input pointer
  word out;        // Output pointer
  pnt q[txqsize1];  // Queue array of pointers
}tx_q_struct;
*/

// Function Prototypes
void InitSCI1(void);
void SCI1_SetBaud(void);
void SCI1_RxQueueInit(void);
void SCI1_StartRx(void);
void SCI1_StopRx(void);
void SCI1_TxQueueInit(void);
void SCI1_PutQueue(char *msg);
void SCI1_StartTx(void);
byte SCI1_GetChar(char *rxbyte);
void SCI1_SendMsg(char *s);
void SCI1_CheckQueue(void);

void SCI1_Rx(void);
void SCI1_Rx1(void);
void SCI1_Rx2(void);

#endif
